;; brain/theme.jl

;; Trying to give all the information posible in every frame
;; mmm no one will use this theme??
;; Based on (and thinmaker "all the others")

(require 'gradient)

(defgroup brain-colors "Colors on brain frame")

(defgroup brain-group "Options on brain frame")

(defcustom brain:normal-from (get-color "steelblue4")
"From color in active frame."
:type color
:group brain-colors
:after-set after-setting-frame-option
)

(defcustom brain:normal-to (get-color "steelblue3")
"To color in active frame."
:type color
:group brain-colors
:after-set after-setting-frame-option
)

(defcustom brain:normal-font (get-color "yellow")
"Font color in active frame."
:type color
:group brain-colors
:after-set after-setting-frame-option
)

(defcustom brain:inactive-from (get-color "gray60")
"From color in inactive frame."
:type color
:group brain-colors
:after-set after-setting-frame-option
)

(defcustom brain:inactive-to (get-color "gray30")
"To color in inactive frame."
:type color
:group brain-colors
:after-set after-setting-frame-option
)

(defcustom brain:inactive-font (get-color "black")
"Font color in inactive frame."
:type color
:group brain-colors
:after-set after-setting-frame-option
)

(defcustom brain:highlighted-from (get-color "steelblue4")
"From color when highlighted."
:type color
:group brain-colors
:after-set after-setting-frame-option
)

(defcustom brain:highlighted-to (get-color "steelblue3")
"To color when highlighted."
:type color
:group brain-colors
:after-set after-setting-frame-option
)

(defcustom brain:highlighted-font (get-color "yellow")
"Font color when highlighted."
:type color
:group brain-colors
:after-set after-setting-frame-option
)

(defcustom brain:reverse-renders t
"Reverse some backgrounds to emulate continuity."
:type boolean
:group brain-colors
:after-set after-setting-frame-option
)

(defcustom brain:save-mem t
"Save memory while making gradients."
:type boolean
:group brain-colors
:after-set after-setting-frame-option
)

(defcustom brain:barsize '12
"Size of bars. Needs a restart."
:type number
:group brain-group
:after-set after-setting-frame-option
:range (9 . 12)
)

(defcustom brain:resizersize '6
"Size of corners to resize."
:type number
:group brain-group
:after-set after-setting-frame-option
:range (3 . 10)
)

(defcustom brain:text-font (get-font "-b&h-lucida-bold-r-normal-*-*-100-*-*-p-*-iso8859-1")
"Font to use in title bars."
:type font
:group brain-group
:after-set after-setting-frame-option
)

(defcustom brain:button-font (get-font "fixed")
"Font to use for button marks."
:type font
:group brain-group
:after-set after-setting-frame-option
)

(let* (

  (my-update (lambda (w) (if (eq (window-get w 'current-frame-style) 'brain) (rebuild-frame w))))

  (four-int-to-string (lambda (four-num) (concat (+ 48 (/ four-num 1000)) (+ 48 (/ (- four-num (* 1000 (/ four-num 1000))) 100)) (+ 48 (/ (- four-num (* 100 (/ four-num 100))) 10)) (+ 48 (- four-num (* 10 (/ four-num 10)))))))

  ;; Para el window-id
  (hex-to-string (lambda (hexnum) (concat "0x"
  (if (< (+ 48 (/ hexnum 16777216)) 58) (+ 48 (/ hexnum 16777216)) (+ 87 (/ hexnum 16777216)) )
  (if (< (+ 48 (/ (- hexnum (* 16777216 (/ hexnum 16777216))) 1048576)) 58) (+ 48 (/ (- hexnum (* 16777216 (/ hexnum 16777216))) 1048576)) (+ 87 (/ (- hexnum (* 16777216 (/ hexnum 16777216))) 1048576)) )
  (if (< (+ 48 (/ (- hexnum (* 1048576 (/ hexnum 1048576))) 65536)) 58 ) (+ 48 (/ (- hexnum (* 1048576 (/ hexnum 1048576))) 65536)) (+ 87 (/ (- hexnum (* 1048576 (/ hexnum 1048576))) 65536)) )
  (if (< (+ 48 (/ (- hexnum (* 65536 (/ hexnum 65536))) 4096)) 58 ) (+ 48 (/ (- hexnum (* 65536 (/ hexnum 65536))) 4096)) (+ 87 (/ (- hexnum (* 65536 (/ hexnum 65536))) 4096)) )
  (if (< (+ 48 (/ (- hexnum (* 4096 (/ hexnum 4096))) 256)) 58 ) (+ 48 (/ (- hexnum (* 4096 (/ hexnum 4096))) 256)) (+ 87 (/ (- hexnum (* 4096 (/ hexnum 4096))) 256)) )
  (if (< (+ 48 (/ (- hexnum (* 256 (/ hexnum 256))) 16)) 58 ) (+ 48 (/ (- hexnum (* 256 (/ hexnum 256))) 16)) (+ 87 (/ (- hexnum (* 256 (/ hexnum 256))) 16)) )
  (if (< (+ 48 (- hexnum (* 16 (/ hexnum 16)))) 58 ) (+ 48 (- hexnum (* 16 (/ hexnum 16)))) (+ 87 (- hexnum (* 16 (/ hexnum 16)))) )
  )))

  ;; Si no lo llamo "vi" a comentarlo
  ;; (two-int-to-string (lambda (two-num) (concat (+ 48 (/ two-num 10)) (+ 48 (- two-num (* 10 (/ two-num 10)))))))

  (bar-bg (lambda (img state) (apply draw-vertical-gradient img (cond 

  ((eq state nil) (list brain:inactive-from brain:inactive-to))
  ((eq state 'focused) (list brain:normal-from brain:normal-to))
  ((eq state 'highlighted) (list brain:highlighted-from brain:highlighted-to))
  (t (list brain:highlighted-from brain:highlighted-to))
   ))
  (when (> cdr (image-dimensions img)) 2) (bevel-image img 1 (not (eq state 'clicked)))
  (set-image-border img 1 1 1 1)
))

  (alternate-render (lambda (img state) (apply draw-vertical-gradient img (cond 

  ((eq state nil) (if brain:reverse-renders (list brain:inactive-to brain:inactive-from) (list brain:inactive-from brain:inactive-to)))
  ((eq state 'focused) (if brain:reverse-renders (list brain:normal-to brain:normal-from) (list brain:normal-from brain:normal-to)))
  ((eq state 'highlighted) (if brain:reverse-renders (list brain:highlighted-to brain:highlighted-from) (list brain:highlighted-from brain:highlighted-to)))
  (t (if brain:reverse-renders (list brain:highlighted-to brain:highlighted-from) (list brain:highlighted-from brain:highlighted-to)))
   ))
  (when (> cdr (image-dimensions img)) 2) (bevel-image img 1 (not (eq state 'clicked)))
  (set-image-border img 1 1 1 1)
))

  (savememory (lambda () (if brain:save-mem 2 1)))

  (barheight (lambda () brain:barsize))

  (resizersize (lambda () brain:resizersize))

  (text-font (lambda () brain:text-font))

  (button-font (lambda () brain:button-font))

  (close-char (lambda () "X"))

  (min-char (lambda () "-"))

  (max-char (lambda () "+"))

  (menu-char (lambda () "B"))

  (font-colors (list brain:inactive-font brain:normal-font brain:highlighted-font nil))

  ;; This one returns a String with the window position (mainly to include in the title and so)...
  ;; Depending on the window width it returns it in a big or in a little format.

  (win-pos (lambda (w) (let ((w-x-pos (car (window-position w))) (w-y-pos (cdr (window-position w))) (w-width (car (window-dimensions w)))) (if (> w-width 150) (concat "x: +" (four-int-to-string w-x-pos) " y: +" (four-int-to-string w-y-pos)) (concat "+" (four-int-to-string w-x-pos) "+" (four-int-to-string w-y-pos))) )))

  ;; idem (eadem idem) but with window size.
  ;; Winsize is currently not used but...

  (win-size (lambda (w) (let ((w-width (car (window-dimensions w))) (w-height (cdr (window-dimensions w)))) (if (> w-width 200) (concat "height: " (four-int-to-string w-height) "  width: " (four-int-to-string w-width)) (concat (four-int-to-string w-height) "/" (four-int-to-string w-width))))))

  (win-size-pos (lambda (w) (let ((w-x-pos (car (window-position w))) (w-y-pos (cdr (window-position w))) (w-width (car (window-dimensions w))) (w-height (cdr (window-dimensions w)))) (if (> w-width 400) (concat "height: " (four-int-to-string w-height) "  width: " (four-int-to-string w-width) " / x: +" (four-int-to-string w-x-pos) " y: +" (four-int-to-string w-y-pos)) (concat (four-int-to-string w-height) "/" (four-int-to-string w-width) " +" (four-int-to-string w-x-pos) "+" (four-int-to-string w-y-pos))))))

  (title-string (lambda (w) (let ((w-id (window-id w))) (concat (window-name w) " (" (hex-to-string w-id) ")"))))

(frame
 `(
   ;; Bar
   ((renderer . ,bar-bg)
    (render-scale . ,savememory)
    (foreground . ,font-colors)
    (text . ,title-string)
    (font . ,text-font)
    (top-edge . ,(- 0 (barheight)))
    (height . ,barheight)
    (left-edge . ,barheight)
    (right-edge . ,barheight)
    (x-justify . center)
    (y-justify . center)
    (class . title))

   ;; other Bar
   ((renderer . ,alternate-render)
    (render-scale . ,savememory)
    (foreground . ,font-colors)
    (text . ,win-size-pos)
    (font . ,text-font)
    (top-edge . ,(- 0 (* 2 (barheight))))
    (height . ,barheight)
    (left-edge . ,barheight)
    (right-edge . ,barheight)
    (x-justify . center)
    (y-justify . center)
    (class . title))

   ;; menu Button
   ((renderer . ,bar-bg)
    (renderer-scale . ,savememory)
    (foreground . ,font-colors)
    (font . ,button-font)
    (text . ,menu-char)
    (top-edge . ,(- 0 (barheight)))
    (left-edge . 0)
    (height . ,barheight)
    (width . ,barheight)
    (x-justify . center)
    (y-justify . center)
    (class . menu-button))

   ;; min Button
   ((renderer . ,bar-bg)
    (renderer-scale . ,savememory)
    (foreground . ,font-colors)
    (font . ,button-font)
    (text . ,min-char)
    (top-edge . ,(- 0 (barheight)))
    (right-edge . 0)
    (height . ,barheight)
    (width . ,barheight)
    (x-justify . center)
    (y-justify . center)
    (class . iconify-button))

   ;; max Button
   ((renderer . ,alternate-render)
    (renderer-scale . ,savememory)
    (foreground . ,font-colors)
    (font . ,button-font)
    (text . ,max-char)
    (top-edge . ,(- 0 (* 2 (barheight))))
    (right-edge . 0)
    (height . ,barheight)
    (width . ,barheight)
    (x-justify . center)
    (y-justify . center)
    (class . maximize-button))

    ;; close Button
   ((renderer . ,alternate-render)
    (renderer-scale . ,savememory)
    (foreground . ,font-colors)
    (font . ,button-font)
    (text . ,close-char)
    (top-edge . ,(- 0 (* 2 (barheight))))
    (left-edge . 0)
    (height . ,barheight)
    (width . ,barheight)
    (x-justify . center)
    (y-justify . center)
    (class . close-button))

   ;; These resizers
   ((renderer . ,bar-bg)
    (renderer-scale . ,savememory)
    (bottom-edge . ,(- 0 (resizersize)))
    (left-edge . ,(* 2 (resizersize)))
    (right-edge . ,(* 2 (resizersize)))
    (height . ,resizersize)
    (class . bottom-border))

  ((renderer . ,alternate-render)
   (renderer-scale . ,savememory)
   (bottom-edge . ,(- 0 (resizersize)))
   (left-edge . 0)
   (height . ,resizersize)
   (width . ,(* 3 (resizersize)))
   (class . bottom-left-corner))

  ((renderer . ,alternate-render)
   (renderer-scale . ,savememory)
   (bottom-edge . ,(- 0 (resizersize)))
   (right-edge . 0)
   (height . ,resizersize)
   (width . ,(* 3 (resizersize)))
   (class . bottom-right-corner))

))

(shaped-frame
 `(
   ;; Bar
   ((renderer . ,bar-bg)
    (render-scale . ,savememory)
    (foreground . ,font-colors)
    (text . ,title-string)
    (font . ,text-font)
    (top-edge . ,(- 0 (barheight)))
    (height . ,barheight)
    (left-edge . ,barheight)
    (right-edge . ,barheight)
    (x-justify . center)
    (y-justify . center)
    (class . title))

   ;; other Bar
   ((renderer . ,alternate-render)
    (render-scale . ,savememory)
    (foreground . ,font-colors)
    (top-edge . ,(- 0 (* 2 (barheight))))
    (text . ,win-pos)
    (font . ,text-font)
    (height . ,barheight)
    (left-edge . ,barheight)
    (right-edge . ,barheight)
    (x-justify . center)
    (y-justify . center)
    (class . title))

   ;; menu Button
   ((renderer . ,bar-bg)
    (renderer-scale . ,savememory)
    (foreground . ,font-colors)
    (font . ,button-font)
    (text . ,menu-char)
    (top-edge . ,(- 0 (barheight)))
    (left-edge . 0)
    (height . ,barheight)
    (width . ,barheight)
    (x-justify . center)
    (y-justify . center)
    (class . menu-button))

   ;; min Button
   ((renderer . ,bar-bg)
    (renderer-scale . ,savememory)
    (foreground . ,font-colors)
    (font . ,button-font)
    (text . ,min-char)
    (top-edge . ,(- 0 (barheight)))
    (right-edge . 0)
    (height . ,barheight)
    (width . ,barheight)
    (x-justify . center)
    (y-justify . center)
    (class . iconify-button))

   ;; max Button
   ((renderer . ,alternate-render)
    (renderer-scale . ,savememory)
    (foreground . ,font-colors)
    (font . ,button-font)
    (text . ,max-char)
    (top-edge . ,(- 0 (* 2 (barheight))))
    (right-edge . 0)
    (height . ,barheight)
    (width . ,barheight)
    (x-justify . center)
    (y-justify . center)
    (class . maximize-button))

    ;; close Button
   ((renderer . ,alternate-render)
    (renderer-scale . ,savememory)
    (foreground . ,font-colors)
    (font . ,button-font)
    (text . ,close-char)
    (top-edge . ,(- 0 (* 2 (barheight))))
    (left-edge . 0)
    (height . ,barheight)
    (width . ,barheight)
    (x-justify . center)
    (y-justify . center)
    (class . close-button))

))



(transient-frame
 `(

   ;; Bar
   ((renderer . ,bar-bg)
    (render-scale . ,savememory)
    (foreground . ,font-colors)
    (text . ,title-string)
    (font . ,text-font)
    (top-edge . ,(- 0 (barheight)))
    (height . ,barheight)
    (left-edge . ,barheight)
    (right-edge . 0)
    (x-justify . center)
    (y-justify . center)
    (class . title))

   ;; other Bar
   ((renderer . ,bar-bg)
    (render-scale . ,savememory)
    (foreground . ,font-colors)
    (bottom-edge . ,(- 0 (barheight)))
    (text . ,win-size-pos)
    (font . ,text-font)
    (height . ,barheight)
    (left-edge . ,barheight)
    (right-edge . 0)
    (x-justify . center)
    (y-justify . center)
    (class . title))

   ;; one close Button
   ((renderer . ,bar-bg)
    (renderer-scale . ,savememory)
    (foreground . ,font-colors)
    (font . ,button-font)
    (text . ,close-char)
    (top-edge . ,(- 0 (barheight)))
    (left-edge . 0)
    (height . ,barheight)
    (width . ,barheight)
    (x-justify . center)
    (y-justify . center)
    (class . close-button))

    ;; another close Button
   ((renderer . ,bar-bg)
    (renderer-scale . ,savememory)
    (foreground . ,font-colors)
    (font . ,button-font)
    (text . ,close-char)
    (bottom-edge . ,(- 0 (barheight)))
    (left-edge . 0)
    (height . ,barheight)
    (width . ,barheight)
    (x-justify . center)
    (y-justify . center)
    (class . close-button))

))
 
(shaped-transient-frame
 `(

   ;; Bar
   ((renderer . ,alternate-render)
    (render-scale . ,savememory)
    (foreground . ,font-colors)
    (text . ,title-string)
    (font . ,text-font)
    (top-edge . ,(- 0 (barheight)))
    (height . ,barheight)
    (left-edge . ,barheight)
    (right-edge . 0)
    (x-justify . center)
    (y-justify . center)
    (class . title))

   ;; other Bar
   ((renderer . ,bar-bg)
    (render-scale . ,savememory)
    (foreground . ,font-colors)
    (top-edge .  0)
    (text . ,win-pos)
    (font . ,text-font)
    (height . ,barheight)
    (left-edge . ,barheight)
    (right-edge . 0)
    (x-justify . center)
    (y-justify . center)
    (class . title))

   ;; one close Button
   ((renderer . ,alternate-render)
    (renderer-scale . ,savememory)
    (foreground . ,font-colors)
    (font . ,button-font)
    (text . ,close-char)
    (top-edge . ,(- 0 (barheight)))
    (left-edge . 0)
    (height . ,barheight)
    (width . ,barheight)
    (x-justify . center)
    (y-justify . center)
    (class . close-button))

    ;; another close Button
   ((renderer . ,bar-bg)
    (renderer-scale . ,savememory)
    (foreground . ,font-colors)
    (font . ,button-font)
    (text . ,close-char)
    (top-edge . 0)
    (left-edge . 0)
    (height . ,barheight)
    (width . ,barheight)
    (x-justify . center)
    (y-justify . center)
    (class . close-button))

))
 


    )

  (add-frame-style 'brain
                   (lambda (w type)
                     (cond ((eq type 'shaped)
                            shaped-frame)
                           ((eq type 'transient)
                            transient-frame)
                           ((eq type 'shaped-transient)
                            shaped-transient-frame)
                           ((eq type 'unframed)
                            nil-frame)
                           (t
                            frame))))

(add-hook 'while-moving-hook my-update)
(add-hook 'after-move-hook my-update)
(add-hook 'while-resizing-hook my-update)
(add-hook 'after-resize-hook my-update)
)

